{{progress=100}}
{{title='Evaluation'}}
{{icon="results"}}
<head>
    <script src="{{=URL('static','js/chartScript.js')}}"></script>
</head>
{{extend 'evaluationLayout.html'}}
<body>
    <div id="graphEconomicDiv">
        <canvas id="graphEconomic"></canvas>
    </div>
     <script>
        //Javascript for the Economic Graph
        function hideEconomicGraph(checkbox){
            var canvas = document.getElementById("graphEconomic");
            canvas.style.display = checkbox.checked ? "none" : "block";
        }
        {{from gluon.serializers import json}}
         var interest = 5; //Standard hurdle rate of 6 percent
        {{if (db().select(db.t_investmentdata.ALL).first() is not None):}}
            {{try:}}
                {{hurdle=db().select(db.t_investmentdata.ALL).first().as_dict()['f_interest']}}
            {{except:}}
                {{hurdle=6}}
            {{pass}}
             interest = {{=hurdle}};
        {{pass}}
        //Prepare the data for the Graph
        //The MainKPI Data
        {{if (db(db.t_goals).select().first().as_dict()['f_roi'] or db(db.t_goals).select().first().as_dict()['f_npv']):}}
        const labels_economic = {{=XML(economicValues[0])}};
        var invest_base = {{=XML(economicValues[1][0]['f_investment'])}};
        var cf_annual = {{=XML(economicValues[1][0]['f_cashflow_yearly'])}};
        var invest_5g = {{=XML(economicValues[1][1]['f_investment'])}};
        var cf_delta_5g = ({{=XML(economicValues[1][1]['f_cashflow_yearly'])}}-cf_annual);
        var invest_5g_lat = {{=XML(economicValues[1][2]['f_investment'])}};
        var cf_delta_5g_lat = ({{=XML(economicValues[1][2]['f_cashflow_yearly'])}}-cf_annual);
        var invest_5g_avail = {{=XML(economicValues[1][3]['f_investment'])}};
        var cf_delta_5g_avail = ({{=XML(economicValues[1][3]['f_cashflow_yearly'])}}-cf_annual);
        var invest_5g_reli = {{=XML(economicValues[1][4]['f_investment'])}};
        var cf_delta_5g_reli = ({{=XML(economicValues[1][4]['f_cashflow_yearly'])}}-cf_annual);
        var invest_5g_ict = {{=XML(economicValues[1][5]['f_investment'])}};
        var cf_delta_5g_ict = ({{=XML(economicValues[1][5]['f_cashflow_yearly'])}}-cf_annual);
        //Loops to calculate NPV for 10 Years
         //Lifetime of the application
        var lifetime = {{=XML(lifetime)}};
         //Function to initialize arrays of length lifetime with 0 as values
        var datas_economic = Array.apply(null, Array(lifetime)).map(function(x,i){return 0});
        var datas_economic_lat = Array.apply(null, Array(lifetime)).map(function(x,i){return 0});
        var datas_economic_avail = Array.apply(null, Array(lifetime)).map(function(x,i){return 0});
        var datas_economic_reli = Array.apply(null, Array(lifetime)).map(function(x,i){return 0});
        var datas_economic_ict = Array.apply(null, Array(lifetime)).map(function(x,i){return 0});
        function updatedatas_economic(invest5g_value, investBase){
            for (x of Array(lifetime).keys()){
                datas_economic[x] = -(invest5g_value-investBase);
                var i = 0;
                while (i != x){
                    i++;
                    datas_economic[x] += ((cf_delta_5g)/((1+interest/100)**i));
                };
            }};
        function updatedatas_economic_lat(invest5g_value, investBase){
            for (x of Array(lifetime).keys()){
                datas_economic_lat[x] = -(invest5g_value-investBase);
                var i = 0;
                while (i != x){
                    i++;
                    datas_economic_lat[x] += ((cf_delta_5g_lat)/((1+interest/100)**i));
                };
            }};
        function updatedatas_economic_avail(invest5g_value, investBase){
            for (x of Array(lifetime).keys()){
                datas_economic_avail[x] = -(invest5g_value-investBase);
                var i = 0;
                while (i != x){
                    i++;
                    datas_economic_avail[x] += ((cf_delta_5g_avail)/((1+interest/100)**i));
                };
            }};
        function updatedatas_economic_reli(invest5g_value, investBase){
            for (x of Array(lifetime).keys()){
                datas_economic_reli[x] = -(invest5g_value-investBase);
                var i = 0;
                while (i != x){
                    i++;
                    datas_economic_reli[x] += ((cf_delta_5g_reli)/((1+interest/100)**i));
                };
            }};
        function updatedatas_economic_ict(invest5g_value, investBase){
            for (x of Array(lifetime).keys()){
                datas_economic_ict[x] = -(invest5g_value-investBase);
                var i = 0;
                while (i != x){
                    i++;
                    datas_economic_ict[x] += ((cf_delta_5g_ict)/((1+interest/100)**i));
                };
            }};
         //Store the lifetime npv back into db
         //TODO
         //db(db.t_applicationData_mobileRobots).update(f_distancestraight = accStraightDistance)
         //db(db.t_ecoValues).update(f_npv_lifetime = datas_economic[lifetime-1])
         //{db.ecoValues.insert(datas_economic[lifetime-1])}
        updatedatas_economic(invest_5g, invest_base);
        updatedatas_economic_lat(invest_base, invest_base);
        updatedatas_economic_avail(invest_base, invest_base);
        updatedatas_economic_reli(invest_base, invest_base);
        updatedatas_economic_ict(invest_5g_ict, invest_base);
        var data_economic = {
            labels: labels_economic,
            datasets: [{
            label: 'With 5G',
            borderColor: 'rgb(64, 122, 170)',
            data: datas_economic,
            },{
            label: 'With 5G - Availability',
            borderColor: 'rgb(121, 121, 121)',
            data: datas_economic_avail,
            },{
            label: 'With 5G - Latency',
            borderColor: 'rgb(0, 168, 170)',
            data: datas_economic_lat,
            },{
            label: 'With 5G - Reliability',
            borderColor: 'rgb(64, 122, 170)',
            data: datas_economic_reli,
            },{
            label: 'With 5G - ICT',
            borderColor: 'rgb(174, 204, 230)',
            data: datas_economic_ict,
            }]
        };
        //Save the canvas in a variable
        const ctx_economic = document.getElementById('graphEconomic');
        var config_economic = {
            type: 'line',
            data: data_economic,
            options: {
                maintainAspectRatio: false,
                responsive: true,
                plugins:{
                    legend: {
                        onHover: function(e) {
                            e.native.target.style.cursor = 'pointer';
                        },
                        labels:{
                            font: {
                                size: 12,
                                weight: 800
                            }
                        }
                    },
                    tooltip: {
                        callbacks: {
                            label: function(context){
                                let label= context.dataset.label || '';
                                if (label) {
                                    label += ': ';
                                }
                                if (context.parsed.y !== null) {
                                    num = Math.round(context.parsed.y);
                                    label += num.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
                                    label += ' €';
                                }
                                return label;
                            },
                            title: function(context){
                                return context[0].parsed.x + '. Year';
                            }
                        }
                    }
                },
                scales:{
                    yAxis:{
                        title:{
                            display: true,
                            text: "Difference between NPV with 4G and NPV with 5G (Mio. €)",
                            font: {
                                size: 16,
                                weight: 800
                            }
                        },
                        ticks:{
                            callback: function(value, index, values) {
                                value = value/1000000;
                                return value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") + ' €';
                            }
                        }
                    },
                    xAxis:{
                        title:{
                            display: true,
                            text: "Year",
                            font: {
                                size: 16,
                                weight: 800
                            }
                        }
                    }
                }
            },
        };

        var myChart_economic = new Chart(
            ctx_economic,
            config_economic
        );
         //Function to change the data in the Economic Graph, type is a number with 0 = Total, 1 = Latency, 2 = Availability, 3 = Reliability, 4 = ICT
        //Probably not used anymore
        /*function changeGraphData(newdata, type){
            myChart_economic.data.datasets[type].data = newdata;
        }
        function changeNPV(){
            for (let x in datas_economic){
                datas_economic[x] = datas_economic[x] - invest;
            }
            var toPrint = datas_economic[1];
            npv_table.innerHTML = toPrint.toFixed(3)  + ' €';
            myChart_economic.update();
        }
        changeNPV();*/
        {{pass}}
    </script>
    <div id="buttonDiv">
            <div id="backToMain"><a href="{{=backUrl}}" class="button">Back</a></div>
            <div id = "nextButton">
                <a id ="nextLink" class="button" href='{{=nextUrl}}'>
                  Continue
                </a>
        </div>
    </div>
    <script>
        nextUrl = new URL(document.getElementById("nextLink").href);
        nextUrl.searchParams.append('npv_delta',datas_economic[lifetime-1]);
         document.getElementById("nextLink").href = nextUrl;
    </script>
</body>
